#include <pthread.h>
#include <stdio.h>
#include <unistd.h>


static int item=0;
static pthread_mutex_t item_lock = PTHREAD_MUTEX_INITIALIZER;


void *producer(void *arg) 
{

  for(;;)
  {
    pthread_mutex_lock(&item_lock);
    if (item == 0) 
    {
      item++;
      printf("I produce\n");
    }
    pthread_mutex_unlock(&item_lock);
    sleep(1); 
  }

  return NULL;
}

void *consumer(void *arg)
{
  for(;;) 
  {
    pthread_mutex_lock(&item_lock);
    /* printf("\t... trying to consume\n"); */
    if (item == 1) 
    {
      item--;
      printf("I consume\n");
    }
    pthread_mutex_unlock(&item_lock);
  }

  return NULL;
}



int main()
{
  pthread_t tid1, tid2;

  pthread_create(&tid1, NULL, producer, NULL);
  pthread_create(&tid2, NULL, consumer, NULL);
  pthread_join(tid1, NULL);
  pthread_join(tid2, NULL);

  return 0;
}
  


