#include <pthread.h>
#include <stdio.h>
#include <unistd.h>



static int item=0;
static pthread_mutex_t item_lock = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t item_cond1 = PTHREAD_COND_INITIALIZER;
static pthread_cond_t item_cond2 = PTHREAD_COND_INITIALIZER;

void *producer(void *arg) 
{

  for(;;)
  {
    pthread_mutex_lock(&item_lock);
    while (item == 1) 
      pthread_cond_wait(&item_cond2, &item_lock);

    item++;
    printf("I produce\n");
    pthread_cond_signal(&item_cond1);
    pthread_mutex_unlock(&item_lock);
    sleep(1);
  }

  return NULL;
}

void *consumer(void *arg)
{

  for(;;) 
  {
    pthread_mutex_lock(&item_lock);
    while(item == 0) 
    {
      printf("\t... waiting to consume\n");
      pthread_cond_wait(&item_cond1, &item_lock);
    }
    

    printf("\t... trying to consume\n");
    item--;
    printf("I consume\n");
    pthread_cond_signal(&item_cond2);
    pthread_mutex_unlock(&item_lock);
  }

  return NULL;
}



int main(int argc, char * argv[])
{
  pthread_t tid1, tid2;

  pthread_create(&tid1, NULL, producer, NULL);
  pthread_create(&tid2, NULL, consumer, NULL);

  pthread_join(tid1, NULL);
  pthread_join(tid2, NULL);

  return 0;
}
  


